/* global hexo */
'use strict';

var pagination = require('hexo-pagination');

var types = hexo.config.types || [];

var list = {};

types.forEach(function (type) {
  list[type] = [];
}, this);

types.forEach(function (type) {
  hexo.extend.generator.register(type, build(type));
}, this);

var init = false;

function _init(pages) {
  pages.forEach(function (page) {
    var layout = page.layout;
    if (list[layout]) {
      list[layout].push(page);
    }
  })
  init = true;
}

function build(type) {
  return function (locals) {
    if (!init) {
      _init(locals.pages);
    }

    var config = this.config;
    var perPage = config.per_page || 10;
    var paginationDir = config.pagination_dir || 'page';

    function generate(path, posts, options) {
      options = options || {};
      return pagination(path, posts, {
        perPage: perPage,
        layout: [type + '_list', 'list', 'archive', 'index'],
        format: paginationDir + '/%d/',
        data: options
      });
    }

    return generate(type, list[type]);
  };
}
